<?php

namespace Drupal\aws_cloud\Controller\Vpc;

/**
 * {@inheritdoc}
 */
interface ApiControllerInterface {

  /**
   * Update all VPCs in particular cloud region.
   *
   * @param string $cloud_context
   *   Cloud context string.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateVpcList($cloud_context);

  /**
   * Update all VPCs of all cloud region.
   */
  public function updateAllVpcList();

  /**
   * Update all VPC Peering Connections in particular cloud region.
   *
   * @param string $cloud_context
   *   Cloud context string.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateVpcPeeringConnectionList($cloud_context);

  /**
   * Update all VPC Peering Connections of all cloud region.
   */
  public function updateAllVpcPeeringConnectionList();

  /**
   * Update all subnets in particular cloud region.
   *
   * @param string $cloud_context
   *   Cloud context string.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateSubnetList($cloud_context);

  /**
   * Update all subnets of all cloud region.
   */
  public function updateAllSubnetList();

  /**
   * Update all Internet Gateways in particular cloud region.
   *
   * @param string $cloud_context
   *   Cloud context string.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateInternetGatewayList($cloud_context);

  /**
   * Update all internet gateways of all cloud region.
   */
  public function updateAllInternetGatewayList();

  /**
   * Update all Carrier Gateways in particular cloud region.
   *
   * @param string $cloud_context
   *   Cloud context string.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateCarrierGatewayList($cloud_context);

  /**
   * Update all carrier gateways of all cloud region.
   */
  public function updateAllCarrierGatewayList();

  /**
   * Update all Transit Gateways in particular cloud region.
   *
   * @param string $cloud_context
   *   Cloud context string.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateTransitGatewayList($cloud_context);

  /**
   * Update all transit gateways of all cloud region.
   */
  public function updateAllTransitGatewayList();

}
