<?php

namespace Drupal\aws_cloud\Entity\Vpc;

use Drupal\aws_cloud\Entity\Ec2\AwsCloudEntityInterface;
use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface defining a Transit Gateway entity.
 *
 * @ingroup aws_cloud
 */
interface TransitGatewayInterface extends ContentEntityInterface, EntityOwnerInterface, AwsCloudEntityInterface {

  /**
   * {@inheritdoc}
   */
  public function getDescription();

  /**
   * {@inheritdoc}
   */
  public function setDescription($description = '');

  /**
   * {@inheritdoc}
   */
  public function getTransitGatewayId();

  /**
   * {@inheritdoc}
   */
  public function setTransitGatewayId($transit_gateway_id = '');

  /**
   * {@inheritdoc}
   */
  public function getAccountId();

  /**
   * {@inheritdoc}
   */
  public function setAccountId($account_id);

  /**
   * {@inheritdoc}
   */
  public function getState();

  /**
   * {@inheritdoc}
   */
  public function setState($state);

  /**
   * {@inheritdoc}
   */
  public function getAmazonSideAsn();

  /**
   * {@inheritdoc}
   */
  public function setAmazonSideAsn($amazon_side_asn);

  /**
   * {@inheritdoc}
   */
  public function getAssociationDefaultRouteTableId();

  /**
   * {@inheritdoc}
   */
  public function setAssociationDefaultRouteTableId($association_default_route_table_id);

  /**
   * {@inheritdoc}
   */
  public function isAutoAcceptSharedAttachments();

  /**
   * {@inheritdoc}
   */
  public function setAutoAcceptSharedAttachments($auto_accept_shared_attachments);

  /**
   * {@inheritdoc}
   */
  public function isDefaultRouteTableAssociation();

  /**
   * {@inheritdoc}
   */
  public function setDefaultRouteTableAssociation($default_route_table_association);

  /**
   * {@inheritdoc}
   */
  public function isDefaultRouteTablePropagation();

  /**
   * {@inheritdoc}
   */
  public function setDefaultRouteTablePropagation($default_route_table_propagation);

  /**
   * {@inheritdoc}
   */
  public function isDnsSupport();

  /**
   * {@inheritdoc}
   */
  public function setDnsSupport($dns_support);

  /**
   * {@inheritdoc}
   */
  public function isMulticastSupport();

  /**
   * {@inheritdoc}
   */
  public function setMulticastSupport($multicast_support);

  /**
   * {@inheritdoc}
   */
  public function getPropagationDefaultRouteTableId();

  /**
   * {@inheritdoc}
   */
  public function setPropagationDefaultRouteTableId($propagation_default_route_table_id);

  /**
   * {@inheritdoc}
   */
  public function isVpnEcmpSupport();

  /**
   * {@inheritdoc}
   */
  public function setVpnEcmpSupport($vpn_ecmp_support);

  /**
   * {@inheritdoc}
   */
  public function getTags();

  /**
   * {@inheritdoc}
   */
  public function setTags(array $tags);

  /**
   * {@inheritdoc}
   */
  public function getRefreshed();

  /**
   * {@inheritdoc}
   */
  public function setRefreshed($time);

  /**
   * {@inheritdoc}
   */
  public function setCreated($created = 0);

  /**
   * {@inheritdoc}
   */
  public function created();

  /**
   * {@inheritdoc}
   */
  public function changed();

}
