<?php

namespace Drupal\k8s\Service\K8sClientExtension\Collections;

use Drupal\k8s\Service\K8sClientExtension\Models\K8sHorizontalPodAutoscalerModel;
use Maclof\Kubernetes\Collections\Collection;

/**
 * K8s priority classes collection.
 */
class K8sHorizontalPodAutoscalerCollection extends Collection {

  /**
   * The constructor.
   *
   * @param array $items
   *   The items.
   */
  public function __construct(array $items) {
    parent::__construct($this->getHorizontalPodAutoscalers($items));
  }

  /**
   * Get an array of horizontal pod autoscalers.
   *
   * @param array $items
   *   The items.
   *
   * @return array
   *   The array of roles.
   */
  protected function getHorizontalPodAutoscalers(array $items): array {
    foreach ($items ?: [] as &$item) {
      if ($item instanceof K8sHorizontalPodAutoscalerModel) {
        continue;
      }

      $item = new K8sHorizontalPodAutoscalerModel($item);
    }

    return $items;
  }

}
