<?php

namespace Drupal\k8s\Service\K8sClientExtension\Repositories;

use Drupal\k8s\Service\K8sClientExtension\Collections\K8sHorizontalPodAutoscalerCollection;
use Maclof\Kubernetes\Repositories\Repository;

/**
 * K8s cluster horizontal pod autoscaler repository.
 */
class K8sHorizontalPodAutoscalerRepository extends Repository {

  /**
   * The uri.
   *
   * @var string
   */
  protected $uri = 'horizontalpodautoscalers';

  /**
   * Whether use namespace or not.
   *
   * @var bool
   */
  protected $namespace = FALSE;

  /**
   * {@inheritdoc}
   */
  protected function createCollection($response): K8sHorizontalPodAutoscalerCollection {
    return new K8sHorizontalPodAutoscalerCollection($response['items']);
  }

  /**
   * {@inheritdoc}
   */
  protected function getApiVersion(): string {
    // @FIXME refactor to avoid duplicate apiVersion def.
    return 'autoscaling/v2beta1';
  }

}
